#!/bin/sh
# wificonn.sh, Wifi Connection
# if the Wifi Dongle Found, Connect Wifi

WIFIDONGLE_ATTATCHED=0
WIFI_DEVICE_NAME="ra0"
WIFI_ESSID=$2
WIFI_SET_IP=$3
WPS_MODE=$1

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	modprobe rt3070sta
	if [[ `ifconfig -a|grep ra0` == "" ]]
	then
		echo "Cannot Find rt3070sta  Wifi Dongle"
		rmmod rt3070sta
		
	else
		WIFIDONGLE_ATTACHED=1
		echo "rt3070sta CONNECTED"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	modprobe rt5370sta
	if [[ `ifconfig -a|grep ra0` == "" ]]
	then
		echo "Cannot Find rt5370sta Wifi Dongle"
		rmmod rt5370sta
		
	else
		WIFIDONGLE_ATTACHED=1
		echo "rt5370sta CONNECTED"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	insmod /usr/etc/rt3370sta.ko
	if [[ `ifconfig -a|grep ra0` == "" ]]
	then
		echo "Cannot Find rt3370sta Wifi Dongle"
		rmmod rt3370sta
		
	else
		WIFIDONGLE_ATTACHED=1
		echo "rt3370sta CONNECTED"
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 0 ]]
then
	modprobe 8192cu
	#insmod /usr/etc/8192cu.ko
	if [[ `ifconfig -a|grep wlan0` == "" ]]
	then
		echo "Cannot Find 8192cu Wifi Dongle"
		rmmod 8192cu
	else
		echo "8192cu CONNECTED"
		WIFIDONGLE_ATTACHED=1
		WIFI_DEVICE_NAME="wlan0"
		ifconfig "$WIFI_DEVICE_NAME" up
		wpa_supplicant -B -i"$WIFI_DEVICE_NAME" -c/usr/etc/wpa.conf -Dwext > /usr/etc/w.log 2>&1
		sleep 5
		iwconfig "$WIFI_DEVICE_NAME" >> /usr/etc/w.log
		udhcpc -i "$WIFI_DEVICE_NAME" -n -t 5 -q
		cur_state=$?
		if [ "$cur_state" == 0 ]
		then
			echo "IP Setting Success"
			ifconfig "$WIFI_DEVICE_NAME" >> /usr/etc/w.log
			aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NETWORK_REMOTE_CONNECT.snd
			exit 0
		else
			echo "IP Setting Fail"
			ifconfig "$WIFI_DEVICE_NAME" >> /usr/etc/w.log
			exit 0
		fi
	fi
fi

if [[ WIFIDONGLE_ATTACHED -eq 1 ]]
then

	if [[ "$WPS_MODE" == "WPS_ON" ]]
	then
		ifconfig "$WIFI_DEVICE_NAME" up
		dropbear
		/usr/rscript/autoconn.sh &
		exit 0
	fi
	
	ifconfig "$WIFI_DEVICE_NAME" up
	iwconfig "$WIFI_DEVICE_NAME" essid "$WIFI_ESSID"
	
	count=0
	while [ true ]
		do			
			if [[ `iwconfig 2>&1| grep 'ESSID'|busybox awk  '{print $4}'| busybox awk -F: '{print $2}'` != "" ]]
			then
				echo "success connect to $WIFI_ESSID"
				aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NETWORK_AP_CONNECTED.snd
				break;
			else
				echo "Try to find $WIFI_ESSID"
				count=$((count+1))
				sleep 1
			fi
			
		if [[ "$count"  > 5 ]]			
		then
			echo "Cannot find $WIFI_ESSID in $count times"
			exit 0
		fi
	done
	
	if [ "$WIFI_SET_IP" == "" ]
	then
		udhcpc -i "$WIFI_DEVICE_NAME" -n -t 5 -q
		cur_state=$?
	else
		ifconfig "$WIFI_DEVICE_NAME" "$WIFI_SET_IP" up
		cur_state=$?
	fi
	
    if [ "$cur_state" == 0 ]
	then
		echo "IP Setting Success"
		aplay -c 1 -r 16000 -f S16_LE /usr/SNDDATA/SND_NETWORK_REMOTE_CONNECT.snd
		updatetime 15 &
		exit 0
	else
		echo "IP Setting Fail"
		exit 0
	fi
fi

exit 1
